function [X, Y, Z, D, Dcell] = util_make_synthetic(Model)
%% function [X, Y, Z, D, Dcell] = util_make_synthetic(Model)
% Make synthetic data for specified model.

N = Model.Nd;
T = Model.T;
Nx = Model.Nx; 
Ny = Model.Ny;
Nz = Model.Nz;

GENERATE_HMM = Model.GENERATE_HMM;

if(GENERATE_HMM)
    [~,Z] = util_sample_HMM2(Model,N);
else
    Z = randsample(Nz,T,true,Model.psi0);
end

Y = zeros(N, T);
X = zeros(N, T);
D(1).id = [];
D(1).cnt = [];
D(1).N = 0;

%Make actual document.
for t = 1 : T
    %Sample topics for each of N words words given psi.
    Y(:,t) = randsample(Ny,N,true,Model.theta(:,Z(t)));
    
    for n = 1 : N
        %Sample word for each topic. Todo: Vectorize.
        X(n,t) = randsample(Nx,1,true,Model.phi(:,Y(n,t)));
    end       
end

%Just make occurance statistics.
for t = 1 : T
    D(t).id = [];
    D(t).cnt = [];
    for x = 1 : Nx
        vidx = (X(:,t)==x);
        cnt = sum(vidx);
        if(cnt>0)
            D(t).id = [D(t).id, x];
            D(t).cnt = [D(t).cnt, cnt];
        end
    end
    Dcell{t}.id = D(t).id;
    Dcell{t}.cnt = D(t).cnt;
end
