function BM = util_recalculateStats_HMM(BM)
%% Recalculate sufficient statistics from raw samples.
% HMM model.
BM.n_xy = zeros(BM.Nx, BM.Ny);  %Latent-obs transition count.
BM.n_yy = zeros(BM.Ny, BM.Ny);  %Cluster-cluster transition count.
BM.n_sxy = zeros(1,BM.Ny);
BM.n_syy = zeros(1,BM.Ny);

BM.n_xy(BM.X(1),BM.sampY_X(1)) = 1; 
for t = 2 : BM.T
    x = BM.X(t); y=BM.sampY_X(t); yo = BM.sampY_X(t-1);
    BM.n_xy(x,y)  = BM.n_xy(x,y)+1;
    BM.n_yy(y,yo) = BM.n_yy(y,yo)+1;
end
BM.n_sxy = sum(BM.n_xy,1);
BM.n_syy = sum(BM.n_yy,1);