function [pD_M, R_s, Y, Z, X] = util_sample_MCLDA(X, Ns, Model)
%% function [Y, Z, pD_M, R_s, X] = util_sample_MCLDA(X, Ns, Model)
% Sample from a MCLDA model's prior. 
% Useful for empirical likelihood based model selection.
% I.e.,
% Generate many samples of {Y,Z} given Model.
% Evaluate p(X|Y)
N = Model.Nd;
Nd = Model.Nd;
T = Model.T;
Nx = Model.Nx; 
Ny = Model.Ny;
Nz = Model.Nz;
BM.Nd = N;
BM.Nx = Nx;
BM.Ny = Ny;
BM.Nz = Nz;
BM.gamma = 1;
BM.beta  = 1;
BM.n_xy  = zeros(Nx, Ny);
BM.n_yy  = [];
BM.n_sxy = zeros(1,Ny);
BM.n_syy = zeros(1,Ny);
BM.T = Nd;
BM.gamma = 1;
BM.beta  = 1;
BM.n_yz  = zeros(Ny,Nz);
BM.n_zz  = zeros(Nz,Nz);
BM.n_szz = zeros(1,Nz);
BM.n_syz = zeros(1,Nz);
BM.n_sym = [];
BM.n_ym = [];
BM.n_z  = 0;
BM.n_sz = 0;

R_s.lpX_Y = zeros(1,Ns);
R_s.lpY   = zeros(1,Ns);
R_s.lpXY  = zeros(1,Ns);
R_s.n_xy  = zeros(Nx,Ny,Ns);
pD_M = 0;
GENERATE_HMM = Model.GENERATE_HMM;

Z = zeros(T, Ns);
Y = zeros(N, T, Ns);

%Make actual document.
for s = 1 : Ns        
    BM.X = X;

    for z = 1 : Nz
        %Sample topic|cluster dist.
        Model.theta(:,z) = dirichlet_sample(ones(Ny,1),1);
    end
    if(GENERATE_HMM)
        for z = 1 : Nz
            Model.psi(:,z) = dirichlet_sample(ones(Nz,1),1);
        end        
        [Y(:,:,s),Z(:,s)] = util_sample_HMM2(Model,N);
    else
        Model.psi0 = dirichlet_sample(ones(Nz,1),1);        
        Z(:,s) = sample(Model.psi0, T);
        for t = 1 : T
            Y(:,t, s) = sample(Model.theta(:,Z(t)), N); %N Words/doc.
        end
    end
%   For if we actually wanted to sample data.    
%     for y = 1 : Ny
%         %Sample word|topic dist.
%         Model.phi(:,y) = dirichlet_sample(ones(Nx,1),1);
%     end
%     for t = 1 : T        
%         for n = 1 : N
%             X(n,t) = sum(cumsum(Model.phi(:, Y(n,t))) < rand) + 1;
%         end       
%     end
    USE_DATA=true;
    if(USE_DATA)
        BM.sampY = Y(:,:,s);
        BM.sampZ = Z(:,s);
        BM = util_recalculateStats_MCLDA(BM,Model);
        [R_s.lpX_Y(1,s)] = util_llh_MCLDA(BM, Model);
        R_s.n_xy(:,:,s) = BM.n_xy;
    end
end
if(USE_DATA)
    pD_M = mean(R_s.lpX_Y(:));
end

