function util_showImgPHI(S,iter)
%% function util_showImgPHI(S)
% Visualize PHI p(words|topic) structure.
% S: Structure.
% Iter: What iteration to print it at.

if(isstruct(S)) %It's a BM structure.
    k=1; Nm = numel(S); Nz = size(S(1).phi_est,2);
    for i = 1 : min(3, Nm)
        for j = 1 : min(4, Nz)
            subplot(3, 4, k); 
            imagesc(reshape(S(i).phi_est(:,j), [5, 5]));  colormap gray;
            k=k+1;
        end
    end
else %It's an phi_est_s matrix.
    [Nx, Ny, Ns, Nm] = size(S);
    if(nargin==1), iter=Ns; end %Show last iteration.
    k=1; 
    for i = 1 : Nm
        for j = 1 : Ny
            subplot(Nm, Ny, k); 
            imagesc(reshape(mean(S(:,j,iter,i), 3), [5, 5])); colormap gray;
            set(gca,'xticklabel',{}); set(gca,'yticklabel',{});
            k=k+1;
        end
    end    
end
k=1;
for i = 1:Ny:Ny*Nm
    subplot(Nm, Ny, i); ylabel(sprintf('Chain %d',k));
    k=k+1;
end
for i = 1 : Ny
    subplot(Nm, Ny, i); title(sprintf('Words | Topic %d',i));
end
